<?php
/**

Post pictures from My Coloring Book to Facebook.

Accepts post from My Coloring Book initially with following post variables...
* name: name of the jpeg file that has been saved containing the posted picture.
* page: name of the original coloring page

When receiving post, checks whether logged in to Facebook.

If logged in then shows form to allow comment and to post to Facebook.

If not logged in then form is hidden, and Facebook login button shown.

For more information check "_READ_ME_.txt".

**/

/****************************************************************************

    YOUR SETTINGS GO HERE...

****************************************************************************/

// Enter YOUR Facebook Application Id and Secret here...
define('FB_APPID', '<your application id>');
define('FB_SECRET', '<your application secret>');

// Enter YOUR Website name and URL here...
define('SITE_NAME', '<your website name>');
define('SITE_URL', '<your website URL>');

// Enter details you want to automatically tag to the photo description here...
define('ADD_TO_MESSAGE', 'Coloring page from '.SITE_NAME.' ('.SITE_URL.')');

// Define the scaled size you want to use for thumbnails...
// (note: Depending on your thumbnail size you may also need to adjust widths
// in style for #thumbnail,#login, #postform etc)
define('THUMBNAIL_SCALE', 0.25); 

/****************************************************************************

    END OF YOUR SETTINGS

****************************************************************************/

// Load Facebook API
require_once 'facebook.php';

Facebook::$CURL_OPTS[CURLOPT_SSL_VERIFYPEER] = false;
Facebook::$CURL_OPTS[CURLOPT_SSL_VERIFYHOST] = 2;

function req($v, $def="")
{
  return array_key_exists($v, $_REQUEST) ? $_REQUEST[$v] : $def;
}

// Create Application instance
$facebook = new Facebook(array(
  'appId'  => FB_APPID,
  'secret' => FB_SECRET,
  'fileUpload' => true
));

$user = $facebook->getUser();
$user_profile = null;
if ($user) {   
  try {
    $user_profile = $facebook->api('/me');
  } catch (FacebookApiException $e) {
    die($e->getMessage());
  }
}

// Request variables
$name = req('name');
$page = req('page');
$imgWidth = intVal(req('imgWidth'));
$imgHeight = intVal(req('imgHeight'));
$tnWidth = round(THUMBNAIL_SCALE * $imgWidth);
$tnHeight = round(THUMBNAIL_SCALE * $imgHeight);

// Ready to post?
$donePost = false;
$post = req('post');
if ($user_profile && $post) {
  $message = req('message');
  if (defined('ADD_TO_MESSAGE') && ADD_TO_MESSAGE != '') {
    if ($message != '') {
      $message .= "\r\n\r\n";
    }
    $message .= ADD_TO_MESSAGE;
  }
  $args = array(
    'message' => $message,
    'image' => '@'.realpath('../'.$name));
  try {
    $res = $facebook->api('/me/photos', 'post', $args);
    $postid = $res['id'];
    $donePost = true;
  } catch (FacebookApiException $e) {
    die($e->getMessage());
  }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"
  xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<title>Send Coloring Page to Facebook</title>
<link rel="stylesheet" type="text/css" href="fbpost.css" />
</head>
<body>
<div id="main">

<div id="thumbnail"><img src="../<?php echo $name; ?>" width="<?php echo $tnWidth;?>" 
height="<?php echo $tnHeight;?>"></div>

<?php if ($donePost) { ?>

<h1>Coloring Page has been posted to Facebook</h1>
<p>Your coloring page has been posted to Facebook.</p>
<?php
if ($postid) {
  echo '<p><a href="http://www.facebook.com/photo.php?fbid='.$postid.'">See the picture.</a></p>';
}
?>
<p>You can now close this window to return to <?php echo SITE_NAME; ?>.</p>

<div><div class="btn"><input type=button value="Close This Window" onclick="javascript:window.close();"></div></div>

<?php } else { ?>

<h1>Post Coloring Page to Facebook</h1>
<div id="login">
<p>You need to log in to Facebook before you can post your picture.</p>
<fb:login-button scope="publish_stream"></fb:login-button></div>

<div id="postform">
<p>Hi <span id="first_name">there</span>,</p>
<p>You can post your colored in picture to your Facebook photo album.</p>
<p>Please enter a caption for the picture and then click <b>Post to Facebook</b>.</p>
<form name="postimage" method="POST">
<div><div class="label">Caption:</div><textarea name="message" class="msg" rows="5" cols="50"></textarea></div>
<div><div class="btn"><input name="post" type="submit" value="Post to Facebook"/></div></div>
<input type="hidden" name="name" value="<?php echo $name; ?>"/>
<input type="hidden" name="page" value="<?php echo $page; ?>"/>
<input type="hidden" name="imgWidth" value="<?php echo $imgWidth; ?>"/>
<input type="hidden" name="imgHeight" value="<?php echo $imgHeight; ?>"/>
</form>
<div id="logout"><img src="http://static.ak.fbcdn.net/rsrc.php/z2Y31/hash/cxrz4k7j.gif" onclick="javascript:fbLogout()"></div>
</div>

<?php } ?>
</div>

<div id="fb-root"></div>
<script type="text/javascript">

function el(id)
{
  return document.getElementById(id);
}

function setVisible(id, vis)
{
  var e = el(id);
  if (vis) {
    e.style.display = 'block';
    e.style.visibility = 'visible';
  } else {
    e.style.display = 'none';
    e.style.visibility = 'hidden';
  }
}

function setText(id, value)
{
  var e = el(id);
  e.innerHTML = value;
}

function fbLogout()
{
  FB.logout();
}

function fbUpdateUser(response) 
{
  setText('first_name', response.first_name);
}

function fbCheckPermission(response)
{
  if (response === '1') {
  } else {
    alert('You have not granted the application permission to post to FaceBook');
  }
}

function fbChange(response)
{
  var connected = (response.status == 'connected');
  setVisible('login', !connected);
  setVisible('postform', connected);
  if (connected) {
    FB.api('/me', fbUpdateUser);
    FB.api({method: 'users.hasAppPermission', ext_perm: 'publish_stream'}, fbCheckPermission);
  }
}

window.fbAsyncInit = function() {
  FB.init({
    appId   : '<?php echo FB_APPID; ?>',
    status  : true, // check login status
    cookie  : true, // Enable cookies to allow the server to access the session
    xfbml   : true, // Parse XFBML
    oauth 	: true  // enable OAuth 2.0
  });
  FB.Event.subscribe('auth.statusChange', fbChange);
  FB.getLoginStatus(fbChange);
};
(function(d){
  var js, id = 'facebook-jssdk'; 
  if (d.getElementById(id)) {
    return;
  }
  js = d.createElement('script'); 
  js.id = id; 
  js.async = true;
  js.src = "//connect.facebook.net/en_US/all.js";
  d.getElementsByTagName('head')[0].appendChild(js);
}(document));

</script>
</body>
</html>
